Index: branches/2.0-beta1/src/PacpusLib/ComponentBase.cpp
===================================================================
--- branches/2.0-beta1/src/PacpusLib/ComponentBase.cpp	(revision 120)
+++ branches/2.0-beta1/src/PacpusLib/ComponentBase.cpp	(revision 152)
@@ -13,17 +13,16 @@
 DECLARE_STATIC_LOGGER("pacpus.core.ComponentBase");
 
-ComponentBase::ComponentBase(const QString& name)
-  : componentName(name)
-  , recording(true)
-  , THREAD_ALIVE(true)
-  , mIsActive(false)
-  , mgr(NULL)
-  , componentState_(NOT_MONITORED)
-  , ui(NULL)
+ComponentBase::ComponentBase(const QString& componentName)
+  : m_componentName(componentName)
+  , m_isActive(false)
+  , m_isRecording(true)
+  , m_manager(NULL)
+  , m_ui(NULL)
+  , m_componentState(NOT_MONITORED)
 {
     LOG_TRACE("constructor");
     // Get a pointer on the instance of ComponentManager.
-    mgr = ComponentManager::getInstance();
-    LOG_INFO("component " << componentName << " was created");
+    m_manager = ComponentManager::getInstance();
+    LOG_INFO("component " << name() << " was created");
 }
 
@@ -33,10 +32,37 @@
 }
 
+bool ComponentBase::isActive() const
+{
+    return m_isActive;
+}
+
+void ComponentBase::setActive(bool isActive)
+{
+    m_isActive = isActive;
+}
+
+bool ComponentBase::isRecording() const
+{
+    return m_isRecording;
+}
+
+void ComponentBase::setRecording(bool isRecording)
+{
+    m_isRecording = isRecording;
+}
+
+const XmlComponentConfig ComponentBase::xmlParameters() const
+{
+    return param;
+}
+
 int ComponentBase::startComponent()
 {
-    if (mIsActive)
-      return false;
-      
-    mIsActive = true;
+    if (isActive()) {
+        LOG_DEBUG("component already started, cannot (re-)start");
+        return false;
+    }
+
+    setActive(true);
     startActivity();
     
@@ -46,8 +72,10 @@
 int ComponentBase::stopComponent()
 {
-    if (!mIsActive)
-      return false;
-
-    mIsActive = false;
+    if (!isActive()) {
+        LOG_DEBUG("component already stopped, cannot (re-)stop");
+        return false;
+    }
+    
+    setActive(false);
     stopActivity();
     
@@ -57,5 +85,5 @@
 void ComponentBase::setState(const COMPONENT_STATE state)
 {
-    componentState_ = state;
+    m_componentState = state;
 }
 
@@ -63,30 +91,63 @@
 ComponentBase::COMPONENT_STATE ComponentBase::getState()
 {
-    COMPONENT_STATE state = componentState_;
-    if (ComponentBase::NOT_MONITORED != componentState_) {
-        componentState_ = ComponentBase::MONITOR_NOK;
+    COMPONENT_STATE state = m_componentState;
+    if (ComponentBase::NOT_MONITORED != m_componentState) {
+        m_componentState = ComponentBase::MONITOR_NOK;
     }
     return state;
 }
 
+ComponentBase::COMPONENT_CONFIGURATION ComponentBase::configurationState() const
+{
+    return m_configurationState;
+}
+
+void ComponentBase::setConfigurationState(COMPONENT_CONFIGURATION state)
+{
+    m_configurationState = state;
+}
+
 bool ComponentBase::isConfigured() const
 {
-    return configuration_ == CONFIGURED_OK;
+    return (m_configurationState == CONFIGURED_OK);
+}
+
+QString ComponentBase::name() const
+{
+    return m_componentName;
 }
 
 QString ComponentBase::getName() const
 {
-     return componentName;
+    return m_componentName;
+}
+
+ComponentBase::InputsMap & ComponentBase::inputs()
+{
+    return m_inputs;
+}
+
+const ComponentBase::InputsMap & ComponentBase::inputs() const
+{
+    return m_inputs;
+}
+
+ComponentBase::OutputsMap & ComponentBase::outputs()
+{
+    return m_outputs;
+}
+
+const ComponentBase::OutputsMap & ComponentBase::outputs() const
+{
+    return m_outputs;
 }
 
 InputInterfaceBase * ComponentBase::getInput(QString inputName) const
 {
-
-    if(input.contains(inputName))
-        return input[inputName];
-    else {
-        LOG_WARN("Component " << componentName << " does not containt input " << inputName);
-        return NULL;
+    if (inputs().contains(inputName)) {
+        return inputs()[inputName];
     }
+    LOG_WARN("Component " << name() << " does not contain input " << inputName);
+    return NULL;
 }
 
@@ -97,19 +158,8 @@
         LOG_INFO("Key : " << keys[i])*/;
 
-    if(output.contains(outputName))
-        return output[outputName];
-    else {
-        LOG_WARN("Component " << componentName << " does not containt output " << outputName);
-        return NULL;
+    if (outputs().contains(outputName)) {
+        return outputs()[outputName];
     }
+    LOG_WARN("Component " << name() << " does not containt output " << outputName);
+    return NULL;
 }
-
-void ComponentBase::addInput()
-{
-
-}
-
-void ComponentBase::addOutput()
-{
-
-}