Index: trunk/lib/FlairCore/src/I2cPort.h
===================================================================
--- trunk/lib/FlairCore/src/I2cPort.h	(revision 169)
+++ trunk/lib/FlairCore/src/I2cPort.h	(revision 170)
@@ -95,5 +95,5 @@
 };
 } // end namespace core
-} // end namespace framework
+} // end namespace flair
 
 #endif // I2CPORT_H
Index: trunk/lib/FlairCore/src/IODataElement.h
===================================================================
--- trunk/lib/FlairCore/src/IODataElement.h	(revision 169)
+++ trunk/lib/FlairCore/src/IODataElement.h	(revision 170)
@@ -56,5 +56,5 @@
 
 } // end namespace core
-} // end namespace framework
+} // end namespace flair
 
 #endif // IODATAELEMENT_H
Index: trunk/lib/FlairCore/src/SerialPort.h
===================================================================
--- trunk/lib/FlairCore/src/SerialPort.h	(revision 169)
+++ trunk/lib/FlairCore/src/SerialPort.h	(revision 170)
@@ -85,5 +85,5 @@
 };
 } // end namespace core
-} // end namespace framework
+} // end namespace flair
 
 #endif // SERIALPORT_H
Index: trunk/lib/FlairMeta/src/MetaUsRangeFinder.cpp
===================================================================
--- trunk/lib/FlairMeta/src/MetaUsRangeFinder.cpp	(revision 169)
+++ trunk/lib/FlairMeta/src/MetaUsRangeFinder.cpp	(revision 170)
@@ -69,3 +69,3 @@
 
 } // end namespace sensor
-} // end namespace framewor
+} // end namespace flair
Index: trunk/lib/FlairMeta/src/MetaVrpnObject.cpp
===================================================================
--- trunk/lib/FlairMeta/src/MetaVrpnObject.cpp	(revision 169)
+++ trunk/lib/FlairMeta/src/MetaVrpnObject.cpp	(revision 170)
@@ -101,3 +101,3 @@
 
 } // end namespace sensor
-} // end namespace framewor
+} // end namespace flair
Index: trunk/lib/FlairSensorActuator/src/BlCtrlV2_x4_speed.cpp
===================================================================
--- trunk/lib/FlairSensorActuator/src/BlCtrlV2_x4_speed.cpp	(revision 169)
+++ trunk/lib/FlairSensorActuator/src/BlCtrlV2_x4_speed.cpp	(revision 170)
@@ -492,3 +492,3 @@
 
 } // end namespace actuator
-} // end namespace framewor
+} // end namespace flair
Index: trunk/lib/FlairSensorActuator/src/Bldc.h
===================================================================
--- trunk/lib/FlairSensorActuator/src/Bldc.h	(revision 169)
+++ trunk/lib/FlairSensorActuator/src/Bldc.h	(revision 170)
@@ -185,4 +185,4 @@
 };
 } // end namespace actuator
-} // end namespace framewor
+} // end namespace flair
 #endif // BLDC_H
Index: trunk/lib/FlairSensorActuator/src/HokuyoUTM30Lx.cpp
===================================================================
--- trunk/lib/FlairSensorActuator/src/HokuyoUTM30Lx.cpp	(revision 169)
+++ trunk/lib/FlairSensorActuator/src/HokuyoUTM30Lx.cpp	(revision 170)
@@ -254,3 +254,3 @@
 
 } // end namespace sensor
-} // end namespace framewor
+} // end namespace flair
Index: trunk/lib/FlairSensorActuator/src/HokuyoUTM30Lx.h
===================================================================
--- trunk/lib/FlairSensorActuator/src/HokuyoUTM30Lx.h	(revision 169)
+++ trunk/lib/FlairSensorActuator/src/HokuyoUTM30Lx.h	(revision 170)
@@ -167,4 +167,4 @@
 };
 } // end namespace sensor
-} // end namespace framewor
+} // end namespace flair
 #endif // HOKUYOUTM30LX_H
Index: trunk/lib/FlairSensorActuator/src/LaserRangeFinder.h
===================================================================
--- trunk/lib/FlairSensorActuator/src/LaserRangeFinder.h	(revision 169)
+++ trunk/lib/FlairSensorActuator/src/LaserRangeFinder.h	(revision 170)
@@ -129,4 +129,4 @@
 };
 } // end namespace sensor
-} // end namespace framewor
+} // end namespace flair
 #endif // LASERRANGEFINDER_H
Index: trunk/lib/FlairSensorActuator/src/Mb800.cpp
===================================================================
--- trunk/lib/FlairSensorActuator/src/Mb800.cpp	(revision 169)
+++ trunk/lib/FlairSensorActuator/src/Mb800.cpp	(revision 170)
@@ -136,3 +136,3 @@
 
 } // end namespace sensor
-} // end namespace framewor
+} // end namespace flair
Index: trunk/lib/FlairSensorActuator/src/Mb800.h
===================================================================
--- trunk/lib/FlairSensorActuator/src/Mb800.h	(revision 169)
+++ trunk/lib/FlairSensorActuator/src/Mb800.h	(revision 170)
@@ -74,4 +74,4 @@
 };
 } // end namespace sensor
-} // end namespace framewor
+} // end namespace flair
 #endif // MB800_H
Index: trunk/lib/FlairSensorActuator/src/NmeaGps.cpp
===================================================================
--- trunk/lib/FlairSensorActuator/src/NmeaGps.cpp	(revision 169)
+++ trunk/lib/FlairSensorActuator/src/NmeaGps.cpp	(revision 170)
@@ -251,3 +251,3 @@
 
 } // end namespace sensor
-} // end namespace framewor
+} // end namespace flair
Index: trunk/lib/FlairSensorActuator/src/NmeaGps.h
===================================================================
--- trunk/lib/FlairSensorActuator/src/NmeaGps.h	(revision 169)
+++ trunk/lib/FlairSensorActuator/src/NmeaGps.h	(revision 170)
@@ -222,4 +222,4 @@
 };
 } // end namespace sensor
-} // end namespace framewor
+} // end namespace flair
 #endif // NMEAGPS_H
Index: trunk/lib/FlairSensorActuator/src/Novatel.cpp
===================================================================
--- trunk/lib/FlairSensorActuator/src/Novatel.cpp	(revision 169)
+++ trunk/lib/FlairSensorActuator/src/Novatel.cpp	(revision 170)
@@ -94,3 +94,3 @@
 
 } // end namespace sensor
-} // end namespace framewor
+} // end namespace flair
Index: trunk/lib/FlairSensorActuator/src/Novatel.h
===================================================================
--- trunk/lib/FlairSensorActuator/src/Novatel.h	(revision 169)
+++ trunk/lib/FlairSensorActuator/src/Novatel.h	(revision 170)
@@ -75,4 +75,4 @@
 };
 } // end namespace sensor
-} // end namespace framewor
+} // end namespace flair
 #endif // Novatel_H
Index: trunk/lib/FlairSensorActuator/src/SimuGps.cpp
===================================================================
--- trunk/lib/FlairSensorActuator/src/SimuGps.cpp	(revision 169)
+++ trunk/lib/FlairSensorActuator/src/SimuGps.cpp	(revision 170)
@@ -164,3 +164,3 @@
 
 } // end namespace sensor
-} // end namespace framewor
+} // end namespace flair
Index: trunk/lib/FlairSensorActuator/src/SimuGps.h
===================================================================
--- trunk/lib/FlairSensorActuator/src/SimuGps.h	(revision 169)
+++ trunk/lib/FlairSensorActuator/src/SimuGps.h	(revision 170)
@@ -102,4 +102,4 @@
 };
 } // end namespace sensor
-} // end namespace framewor
+} // end namespace flair
 #endif // SIMUGPS_H